#ifndef __X10_ARRAY_ARRAY__ANONYMOUS__13753_H
#define __X10_ARRAY_ARRAY__ANONYMOUS__13753_H

#include <x10rt.h>


#define X10_LANG_OBJECT_H_NODEPS
#include <x10/lang/Object.h>
#undef X10_LANG_OBJECT_H_NODEPS
#define X10_LANG_ITERABLE_H_NODEPS
#include <x10/lang/Iterable.h>
#undef X10_LANG_ITERABLE_H_NODEPS
namespace x10 { namespace array { 
template<class TPMGL(T)> class Array;
} } 
namespace x10 { namespace array { 
template<class TPMGL(T31872)> class Array__Anonymous__13753__Anonymous__13810;
} } 
namespace x10 { namespace array { 

template<class TPMGL(T31871)> class Array__Anonymous__13753;
template <> class Array__Anonymous__13753<void>;
template<class TPMGL(T31871)> class Array__Anonymous__13753 : public x10::lang::Object
  {
    public:
    RTT_H_DECLS_CLASS
    
    static x10aux::itable_entry _itables[3];
    
    virtual x10aux::itable_entry* _getITables() { return _itables; }
    
    static typename x10::lang::Iterable<TPMGL(T31871)>::template itable<x10::array::Array__Anonymous__13753<TPMGL(T31871)> > _itable_0;
    
    static x10::lang::Any::itable<x10::array::Array__Anonymous__13753<TPMGL(T31871)> > _itable_1;
    
    x10aux::ref<x10::array::Array<TPMGL(T31871)> > FMGL(out__);
    
    virtual x10aux::ref<x10::lang::Iterator<TPMGL(T31871)> > iterator(
      );
    void _constructor(x10aux::ref<x10::array::Array<TPMGL(T31871)> > out__);
    
    static x10aux::ref<x10::array::Array__Anonymous__13753<TPMGL(T31871)> > _make(
             x10aux::ref<x10::array::Array<TPMGL(T31871)> > out__);
    
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};
template <> class Array__Anonymous__13753<void> : public x10::lang::Object
{
    public:
    static x10aux::RuntimeType rtt;
    static const x10aux::RuntimeType* getRTT() { return & rtt; }
    
};

} } 
#endif // X10_ARRAY_ARRAY__ANONYMOUS__13753_H

namespace x10 { namespace array { 
template<class TPMGL(T31871)> class Array__Anonymous__13753;
} } 

#ifndef X10_ARRAY_ARRAY__ANONYMOUS__13753_H_NODEPS
#define X10_ARRAY_ARRAY__ANONYMOUS__13753_H_NODEPS
#include <x10/lang/Object.h>
#include <x10/lang/Iterable.h>
#include <x10/array/Array.h>
#include <x10/array/Array__Anonymous__13753__Anonymous__13810.h>
#ifndef X10_ARRAY_ARRAY__ANONYMOUS__13753_H_GENERICS
#define X10_ARRAY_ARRAY__ANONYMOUS__13753_H_GENERICS
#endif // X10_ARRAY_ARRAY__ANONYMOUS__13753_H_GENERICS
#ifndef X10_ARRAY_ARRAY__ANONYMOUS__13753_H_IMPLEMENTATION
#define X10_ARRAY_ARRAY__ANONYMOUS__13753_H_IMPLEMENTATION
#include <x10/array/Array__Anonymous__13753.h>

template<class TPMGL(T31871)> typename x10::lang::Iterable<TPMGL(T31871)>::template itable<x10::array::Array__Anonymous__13753<TPMGL(T31871)> >  x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_itable_0(&x10::array::Array__Anonymous__13753<TPMGL(T31871)>::equals, &x10::array::Array__Anonymous__13753<TPMGL(T31871)>::hashCode, &x10::array::Array__Anonymous__13753<TPMGL(T31871)>::iterator, &x10::array::Array__Anonymous__13753<TPMGL(T31871)>::toString, &x10::array::Array__Anonymous__13753<TPMGL(T31871)>::typeName);
template<class TPMGL(T31871)> x10::lang::Any::itable<x10::array::Array__Anonymous__13753<TPMGL(T31871)> >  x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_itable_1(&x10::array::Array__Anonymous__13753<TPMGL(T31871)>::equals, &x10::array::Array__Anonymous__13753<TPMGL(T31871)>::hashCode, &x10::array::Array__Anonymous__13753<TPMGL(T31871)>::toString, &x10::array::Array__Anonymous__13753<TPMGL(T31871)>::typeName);
template<class TPMGL(T31871)> x10aux::itable_entry x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_itables[3] = {x10aux::itable_entry(&x10aux::getRTT<x10::lang::Iterable<TPMGL(T31871)> >, &_itable_0), x10aux::itable_entry(&x10aux::getRTT<x10::lang::Any>, &_itable_1), x10aux::itable_entry(NULL, (void*)x10aux::getRTT<x10::array::Array__Anonymous__13753<TPMGL(T31871)> >())};

//#line 55 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10FieldDecl_c

//#line 381 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(T31871)> x10aux::ref<x10::lang::Iterator<TPMGL(T31871)> >
  x10::array::Array__Anonymous__13753<TPMGL(T31871)>::iterator() {
    
    //#line 381 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10Return_c
    return x10aux::class_cast_unchecked<x10aux::ref<x10::lang::Iterator<TPMGL(T31871)> > >(x10::array::Array__Anonymous__13753__Anonymous__13810<TPMGL(T31871)>::_make(((x10aux::ref<x10::array::Array__Anonymous__13753<TPMGL(T31871)> >)this)));
    
}

//#line 380 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10ConstructorDecl_c
template<class TPMGL(T31871)> void x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_constructor(
                                x10aux::ref<x10::array::Array<TPMGL(T31871)> > out__) {
    
    //#line 380 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10ConstructorCall_c
    (this)->::x10::lang::Object::_constructor();
    
    //#line 55 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": Eval of x10.ast.X10FieldAssign_c
    ((x10aux::ref<x10::array::Array__Anonymous__13753<TPMGL(T31871)> >)this)->
      FMGL(out__) = out__;
}
template<class TPMGL(T31871)> x10aux::ref<x10::array::Array__Anonymous__13753<TPMGL(T31871)> > x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_make(
                                x10aux::ref<x10::array::Array<TPMGL(T31871)> > out__)
{
    x10aux::ref<x10::array::Array__Anonymous__13753<TPMGL(T31871)> > this_ = new (memset(x10aux::alloc<x10::array::Array__Anonymous__13753<TPMGL(T31871)> >(), 0, sizeof(x10::array::Array__Anonymous__13753<TPMGL(T31871)>))) x10::array::Array__Anonymous__13753<TPMGL(T31871)>();
    this_->_constructor(out__);
    return this_;
}


template<class TPMGL(T31871)> const x10aux::serialization_id_t x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_serialization_id = 
    x10aux::DeserializationDispatcher::addDeserializer(x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_deserializer, x10aux::CLOSURE_KIND_NOT_ASYNC);

template<class TPMGL(T31871)> void x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_serialize_body(x10aux::serialization_buffer& buf) {
    x10::lang::Object::_serialize_body(buf);
    buf.write(this->FMGL(out__));
    
}

template<class TPMGL(T31871)> x10aux::ref<x10::lang::Reference> x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_deserializer(x10aux::deserialization_buffer& buf) {
    x10aux::ref<x10::array::Array__Anonymous__13753<TPMGL(T31871)> > this_ = new (memset(x10aux::alloc<x10::array::Array__Anonymous__13753<TPMGL(T31871)> >(), 0, sizeof(x10::array::Array__Anonymous__13753<TPMGL(T31871)>))) x10::array::Array__Anonymous__13753<TPMGL(T31871)>();
    buf.record_reference(this_);
    this_->_deserialize_body(buf);
    return this_;
}

template<class TPMGL(T31871)> void x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_deserialize_body(x10aux::deserialization_buffer& buf) {
    x10::lang::Object::_deserialize_body(buf);
    FMGL(out__) = buf.read<x10aux::ref<x10::array::Array<TPMGL(T31871)> > >();
}

template<class TPMGL(T31871)> x10aux::RuntimeType x10::array::Array__Anonymous__13753<TPMGL(T31871)>::rtt;
template<class TPMGL(T31871)> void x10::array::Array__Anonymous__13753<TPMGL(T31871)>::_initRTT() {
    const x10aux::RuntimeType *canonical = x10aux::getRTT<x10::array::Array__Anonymous__13753<void> >();
    if (rtt.initStageOne(canonical)) return;
    const x10aux::RuntimeType* parents[2] = { x10aux::getRTT<x10::lang::Object>(), x10aux::getRTT<x10::lang::Iterable<TPMGL(T31871)> >()};
    const x10aux::RuntimeType* params[1] = { x10aux::getRTT<TPMGL(T31871)>()};
    x10aux::RuntimeType::Variance variances[1] = { x10aux::RuntimeType::invariant};
    const char *baseName = "x10.array.Array.Anonymous.13753";
    rtt.initStageTwo(baseName, x10aux::RuntimeType::class_kind, 2, parents, 1, params, variances);
}
#endif // X10_ARRAY_ARRAY__ANONYMOUS__13753_H_IMPLEMENTATION
#endif // __X10_ARRAY_ARRAY__ANONYMOUS__13753_H_NODEPS
